function varargout=plotmesh(q,me,varargin)
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('color','blue');
  p.addParamValue('Tag','');
  %p.addParamValue('inlegend',false,@islogical);
  p.addParamValue('type','simplicial');
  p.addParamValue('DisplayName','',@ischar);
  p.parse(varargin{:});
  R=p.Results;
  varargin=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  varargin=fc_tools.graphics.xcolor.color_varargin(varargin,{'EdgeColor','FaceColor'});
  if ~isempty(R.DisplayName), varargin={varargin{:},'DisplayName',R.DisplayName};end
  if strcmp(R.type,'simplicial')
    dim=size(q,1);d=size(me,1)-1;
    H=eval(sprintf('PlotSubTh%dsimp%dD(q,me,fc_tools.graphics.xcolor.val2rgb(R.color),R.Tag,varargin{:})',d,dim));
  else
    error('Unknow type ''%s''',R.type)
  end
  if isempty(R.DisplayName) && ~fc_tools.comp.isOctave()
    hAnnotation = get(H,'Annotation');
    hLegendEntry = get(hAnnotation','LegendInformation');
    set(hLegendEntry,'IconDisplayStyle','off')
  end
  if nargout==1,varargout{1}=H;end
end

function h=PlotSubTh3simp3D(q,me,Color,Tag,varargin)
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('cutPlan',[]);
  p.addParamValue('move',[]);
  p.parse(varargin{:});
  P=p.Results.cutPlan;
  move=p.Results.move;
  PlotOptions=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  view(3)
  idxme=fc_graphics4mesh.cutIndex(q,me,P);
  Q=move_mesh(q,move);
  if fc_tools.comp.isOctave()
    T=me(:,idxme)';
    triang = [T(:, 1) T(:, 2) T(:, 3); ...
              T(:, 2) T(:, 3) T(:, 4); ...
              T(:, 3) T(:, 4) T(:, 1); ...
              T(:, 4) T(:, 1) T(:, 2)];
    if isempty(P)
      h=patch('faces',triang,'vertices',Q','FaceColor','none', ...
                'EdgeColor',Color,'Tag',Tag,PlotOptions{:});
    else
      h=patch('faces',triang,'vertices',Q','FaceColor',Color, ...
                'Tag',Tag,PlotOptions{:});
    end
  else
    if isempty(P)
      idx=nchoosek(1:4,2);
      ME=[];
      for i=1:size(idx,1) % speedup with patch insteed of tetramesh?
        ME=[ME;me(idx(i,:),idxme)'];
      end
      h=patch('Vertices',Q','Faces',ME,'EdgeColor',Color,'FaceColor','none','Tag',Tag,PlotOptions{:});
    else
      T=me(:,idxme)';
      triang = [T(:, 1) T(:, 2) T(:, 3); ...
              T(:, 2) T(:, 3) T(:, 4); ...
              T(:, 3) T(:, 4) T(:, 1); ...
              T(:, 4) T(:, 1) T(:, 2)];
      h=patch('Vertices',Q','Faces',triang,'FaceColor',Color,'Tag',Tag,PlotOptions{:});
    end
  end
end

function h=PlotSubTh2simp3D(q,me,Color,Tag,varargin)
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('cutPlan',[]);
  p.addParamValue('move',[]);
  p.addParamValue('EdgeColor','k');
  p.addParamValue('faceColor',Color);
  p.parse(varargin{:});
  P=p.Results.cutPlan;
  R=p.Results;
  PlotOptions=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  idxme=fc_graphics4mesh.cutIndex(q,me,P);
  qq=move_mesh(q,p.Results.move);
%    Q=[0 0 0;1 0 0;0 1 0];ME=[1 2 3];
%    h1=trimesh(ME,Q(:,1),Q(:,2),Q(:,3),'EdgeColor','k','faceColor',Color,'Tag',Tag,PlotOptions{:},'Visible','Off');
  h=trimesh(me(:,idxme)',qq(1,:),qq(2,:),qq(3,:),'EdgeColor',R.EdgeColor,'faceColor',R.faceColor,'Tag',Tag,PlotOptions{:});
%    
%    set(h,'Visible','On')
end

function h=PlotSubTh1simp3D(q,me,Color,Tag,varargin)
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('cutPlan',[]);
  p.addParamValue('move',[]);
  p.parse(varargin{:});
  P=p.Results.cutPlan;
  PlotOptions=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  idxme=fc_graphics4mesh.cutIndex(q,me,P);n=length(idxme);
  qq=move_mesh(q,p.Results.move);
  X=[qq(1,me(1,idxme));qq(1,me(2,idxme));NaN(1,n)];
  Y=[qq(2,me(1,idxme));qq(2,me(2,idxme));NaN(1,n)];
  Z=[qq(3,me(1,idxme));qq(3,me(2,idxme));NaN(1,n)];
  h=plot3(X(:),Y(:),Z(:),'Color',Color,'Tag',Tag,PlotOptions{:});
end

function h=PlotSubTh0simp3D(q,me,Color,Tag,varargin)
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('cutPlan',[]);
  p.addParamValue('move',[]);
  p.parse(varargin{:});
  P=p.Results.cutPlan;
  move=p.Results.move;
  PlotOptions=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  if isempty(P)
    idxme=1:size(q,2);
  else
    idxme=unique(fc_graphics4mesh.cutIndex(q,me,P));
  end
  qq=move_mesh(q,move);
  h=plot3(qq(1,idxme),qq(2,idxme),qq(3,idxme),'LineStyle','none','Marker','o','MarkerFaceColor',Color','Color',Color,'Tag',Tag,PlotOptions{:});
end

function h=PlotSubTh2simp2D(q,me,Color,Tag,varargin)
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('move',[]);
  p.addParamValue('fill',false,@islogical);
  p.addParamValue('EdgeColor','None');
  p.addParamValue('z',[]);
  p.parse(varargin{:});
  PlotOptions=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  if isempty(p.Results.z)
    qq=move_mesh(q,p.Results.move);
    if p.Results.fill
      H=patch('Faces',me','Vertices',q','FaceColor',Color,'EdgeColor',p.Results.EdgeColor,'Tag',Tag,PlotOptions{:});
      %H=patch('Faces',me','Vertices',q','FaceColor',Color,'Tag',Tag,PlotOptions{:});
    else
      H=triplot(me',qq(1,:),qq(2,:),'Color',Color,'Tag',Tag,PlotOptions{:});
    end
    h=H(1);
  else
    z=fc_graphics4mesh.evalAtVertices(p.Results.z,q).';
    qq=move_mesh(q,p.Results.move);
    Q=[qq;z];
    %whos
    if p.Results.fill
      h=PlotSubTh2simp3D(Q,me,Color,Tag,'FaceColor',Color,'EdgeColor',p.Results.EdgeColor,PlotOptions{:});
    else
      h=PlotSubTh2simp3D(Q,me,Color,Tag,PlotOptions{:});
    end  
  end
end

function h=PlotSubTh1simp2D(q,me,Color,Tag,varargin)
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('move',[]);
  p.addParamValue('z',[]);
  p.parse(varargin{:});
  PlotOptions=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  nme=size(me,2);
  qq=move_mesh(q,p.Results.move);
  X=[qq(1,me(1,:));qq(1,me(2,:));NaN(1,nme)];
  Y=[qq(2,me(1,:));qq(2,me(2,:));NaN(1,nme)];
  if isempty(p.Results.z)
    h=plot(X(:),Y(:),'Color',Color,'Tag',Tag,PlotOptions{:}); 
  else
    z=fc_graphics4mesh.evalAtVertices(p.Results.z,q).';
    Z=[z(me(1,:));z(me(2,:));NaN(1,nme)];
    h=plot3(X(:),Y(:),Z(:),'Color',Color,'Tag',Tag,PlotOptions{:}); 
  end
end

function h=PlotSubTh0simp2D(q,me,Color,Tag,varargin)
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('move',[]);
  p.parse(varargin{:});
  PlotOptions=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  qq=move_mesh(q,p.Results.move);
  h=plot(qq(1,:),qq(2,:),'LineStyle','none','Marker','o','MarkerFaceColor',Color','Color',Color,'Tag',Tag,PlotOptions{:});
end

function h=PlotSubTh1simp1D(q,me,Color,Tag,varargin)
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('move',[]);
  p.parse(varargin{:});
  PlotOptions=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  nme=size(me,2);
  qq=move_mesh(q,p.Results.move);
  h=line(qq(1,me(1,:)),zeros(nme,1),'Color',Color,'Tag',Tag,PlotOptions{:}); 
end

function h=PlotSubTh0simp1D(q,me,Color,Tag,varargin)
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('move',[]);
  p.parse(varargin{:});
  PlotOptions=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  qq=move_mesh(q,p.Results.move);
  h=plot(qq(1,:),qq(2,:),'LineStyle','none','Marker','o','MarkerFaceColor',Color','Color',Color,'Tag',Tag,PlotOptions{:});
end

function Q=move_mesh(q,move)
  if ~isempty(move)
    assert( sum(size(move)~=size(q))==0 )
    Q=q+move;
  else
    Q=q;
  end
end
